import java.util.Stack;
import com.nttdocomo.ui.Canvas;
import com.nttdocomo.ui.Display;
import com.nttdocomo.ui.Font;
import com.nttdocomo.ui.Graphics;
import com.nttdocomo.ui.IApplication;

public class IappMain extends IApplication{	
	public void start(){
		Display.setCurrent(new MyCvs());
	}
}

class MyCvs extends Canvas{
	Graphics g;
	
	public void paint(Graphics g) {
		this.g = g;

		String str = "<b><s=small><c=0,0,255>draw<c=0,255,0>Tag</c>String()</c></s></b>𗘗p΁A" +
			"<c=0,200,0></c>ȒP<u><c=255,0,0></c></u>ĕ\ł܂B<br><b><u>^O" +
			"qOK</u></b>B<s=small><c=255,0,0>wӏ</c></s>Ft葾ɂĂ̂" +
			"ō<s=medium><c=255,0,255><b>\ʓ|</b></c></s>łH";

		drawTagString(str, 20, 30, 220, 25);
	}
	
	/**
	 * `ꂽ^O𗘗pĕ𑕏`悷
	 * 
	 * yp\^Oz
	 *   TCYݒ	<s=TCY>...</s> itiny, small, medium, large w\j
	 *   Fݒ	  	<c=R,G,B>...</c>
	 *   			      <b>...</b>
	 *   A_[C	<u>...</u>
	 *   s			      <br>
	 * 
	 * @param str			^O܂񂾕
	 * @param cvsStX		`JnʒuX
	 * @param cvsStY		`JnʒuY
	 * @param cvsEnX		`IʒuX
	 * @param lineHeight	s
	 */
	public void drawTagString(String str, int cvsStX, int cvsStY, int cvsEnX, int lineHeight){

		int x = cvsStX;
		int y = cvsStY;

		int len = str.length();
		int idxSt = 0;
		int tagSt = 0;
		int tagEn = 0;

		String now = "";
		String next = "";

		setFont(FONT_TINY);

		while(idxSt < len){

			now = str.substring(idxSt, idxSt+1);			
			int[] fs = getFontSize(now);
			int xmgn = fs[0]+2;
			
			if(now.equals("<")){				
				next = str.substring(idxSt+1, idxSt+2);
				//I^O
				if(next.equals("/")){					
					tagSt = idxSt+1;
					tagEn = str.indexOf(">", tagSt);
					disableTag(str.substring(tagSt+1, tagEn));
				//Jn^O
				}else{
					tagSt = idxSt;
					tagEn = str.indexOf(">", tagSt);
					enableTag(str.substring(tagSt+1, tagEn));
				}				
				idxSt = tagEn;
			
			}else{			
				//System.out.print(now);
				if(USE_BR){
					x = cvsStX;
					y += lineHeight;
					//s^O͏IȂ̂
					disableTag(TAG_BR);
				}
				if(x >= cvsEnX){
					x = cvsStX;
					y+=lineHeight;
				}

				g.drawString(now, x, y);
				if(USE_BOLD) g.drawString(now, x+1, y);
				if(USE_ULINE) g.drawLine(x, y, x+xmgn, y);				
				x+=xmgn;
			}
			idxSt++;			
		}		
	}
	

	//********************************************
	//	^O֘A
	//********************************************	
	

	private static final String TAG_BOLD = "b";
	private static final String TAG_ULINE = "u";
	private static final String TAG_COLOR = "c";
	private static final String TAG_BR = "br";
	private static final String TAG_SIZE = "s";

	private boolean USE_BOLD = false;	
	private boolean USE_ULINE = false;
	private boolean USE_BR = false;
	
	private Stack color = new Stack(); //Fޔp
	private Stack font = new Stack();	//tHgTCYޔp
		
	
	/**
	 * w^OLɂ
	 * @param tag
	 */
	private void enableTag(String tag){
		String[] elem = split(tag, "=");
		
		if(elem[0].equals(TAG_BOLD)) USE_BOLD = true;
		else if(elem[0].equals(TAG_BR)) USE_BR = true;
		else if(elem[0].equals(TAG_ULINE)) USE_ULINE = true;
		else if(elem[0].equals(TAG_COLOR)){
			color.push(getLastColor());			
			int[] c = splitInt(elem[1], ",");
			setColorRGB(c[0], c[1], c[2]);
		}
		else if(elem[0].equals(TAG_SIZE)){			
			font.push(new int[]{getFontType()});
			int size = FONT_TINY;
			if(elem[1].equals("small")) size = FONT_SMALL;
			else if(elem[1].equals("medium")) size = FONT_MEDIUM;
			else if(elem[1].equals("large")) size = FONT_LARGE;				
			setFont(size);
		}
	}
	
	
	/**
	 * w^O𖳌ɂ
	 * @param tag
	 */
	private void disableTag(String tag){
		if(tag.equals(TAG_BOLD)) USE_BOLD = false;
		else if(tag.equals(TAG_BR)) USE_BR = false;
		else if(tag.equals(TAG_ULINE)) USE_ULINE = false;
		else if(tag.equals(TAG_COLOR)){			
			int[] c = (int[])color.pop();			
			setColorRGB(c[0], c[1], c[2]);
		}
		else if(tag.equals(TAG_SIZE)){
			int[] f = (int[]) font.pop();			
			setFont(f[0]);
		}
	}
	
	
	//********************************************
	//	֘A
	//********************************************	

	
	/**
	 * w蕶ŕ
	 * @param str	Ώە	
	 * @param tg	؂蕶
	 * @return
	 */
	public String[] split(String str, String tg){
				
		int st = 0;
		int end = 0;
		int cnt = 0;
		
		// vfJEg
		for(;;){
			st = str.indexOf(tg, st);
			cnt++; 
			if(st == -1) break;
			st++; 
		}
		String[] ret = new String[cnt];

		// 
		st = 0; 
		end = 0;		
		for(int i=0; i<cnt; i++){			
			end = str.indexOf(tg, st);
			if(end == -1){
				ret[i] = str.substring(st, str.length());
				break;
			}
			ret[i] = str.substring(st, end);			
			st = end+1;
		}				
		return ret;
	}
	
	
	/**
	 * w蕶ŕintŕԂ
	 * @param str	Ώە	
	 * @param tg	؂蕶
	 * @return
	 */
	public int[] splitInt(String str, String tg){
		String[] p = split(str, tg);
		int[] ret = new int[p.length];
		for(int i=0; i<p.length; i++){
			ret[i] = Integer.parseInt(p[i]);
		}
		return ret;
	}
	
	
	//********************************************
	//	F֘A
	//********************************************	

	
	private int[] lastColor;
	
	public int[] getLastColor(){
		if(lastColor==null){
			return new int[]{0,0,0};
		}else{
			return lastColor;
		}
	}
	
	public void setColorRGB(int c1,int c2,int c3) {
		g.setColor(Graphics.getColorOfRGB(c1,c2,c3));
		lastColor = new int[]{c1, c2, c3};
	}


	//********************************************
	//	tHg֘A
	//********************************************	

	
	public static int FONT_TINY = Font.SIZE_TINY;
	public static int FONT_SMALL = Font.SIZE_SMALL;
	public static int FONT_MEDIUM = Font.SIZE_MEDIUM;
	public static int FONT_LARGE = Font.SIZE_LARGE;	

	private static Font activeFont;
	private static int activeSize;

	public void setFont(int fontType){
		activeFont = Font.getFont(fontType);
		activeSize = fontType;
		g.setFont(activeFont);
	}
	
	public int[] getFontSize(String s){
		return new int[]{activeFont.stringWidth(s), activeFont.getHeight()}; 
	}

	public int getFontType(){
		return activeSize;
	}

	
}
